# MixEF Class Reference

Mixture of Exponential Family Densities. More...

`#include <mixef.h>`

Inheritance diagram for MixEF:

[legend]
Collaboration diagram for MixEF:

[legend]

List of all members.

## Public Member Functions
| MixEF (const Array< BMEF * > &Coms0, const vec &alpha0)
| Full constructor.
| MixEF ()
| Constructor of empty mixture.
| MixEF (const MixEF &M2)
| Copy constructor.
void | init (BMEF *Com0, const mat &Data, int c=5)
void | bayes (const vec &dt)
| Recursive EM-like algorithm (QB-variant), see Karny et. al, 2006.
void | bayes (const mat &dt)
| EM algorithm.
void | bayesB (const mat &dt, const vec &wData)
double | logpred (const vec &dt) const
const epdf & | _epdf () const
| Returns a reference to the epdf representing posterior density on parameters.
const eprod * | _e () const
| Returns a pointer to the epdf representing posterior density on parameters. Use with care!
emix * | predictor (const RV &rv) const
| Constructs a predictive density (marginal density on data).
void | flatten (const BMEF *M2)
| Flatten the density as if it was not estimated from the data.
BMEF * | _Coms (int i)
| Access function.
void | set_method (MixEF_METHOD M)
| Set which method is to be used.
virtual void | set_statistics (const BMEF *BM0)
| get statistics from another model
virtual void | bayes (const vec &data, const double w)
| Weighted update of sufficient statistics (Bayes rule).
BMEF * | _copy_ (bool changerv=false)
| Flatten the posterior as if to keep nu0 data.
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
const RV & | _rv () const
| access function
double | _ll () const
| access function
void | set_evalll (bool evl0)
| access function
## Protected Member Functions
void | build_est ()
| Auxiliary function for use in constructors.
## Protected Attributes
int | n
| Number of components.
Array< BMEF * > | Coms
| Models for Components of .
multiBM | weights
| Statistics for weights.
eprod * | est
| Posterior on component parameters.
MixEF_METHOD | method
| Flag for a method that is used in the inference.
double | frg
| forgetting factor
double | last_lognc
| cached value of lognc() in the previous step (used in evaluation of `ll` )
RV | rv
| Random variable of the posterior.
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.

## Detailed Description

Mixture of Exponential Family Densities.

An approximate estimation method for models with latent discrete variable, such as mixture models of the following kind:

where is a known function of past outputs, are component weights, and component parameters are assumed to be mutually independent. is an aggregation af all component parameters and weights, i.e. .

The characteristic feature of this model is that if the exact values of the latent variable were known, estimation of the parameters can be handled by a single model. For example, for the case of mixture models, posterior density for each component parameters would be a BayesianModel from Exponential Family.

This class uses EM-style type algorithms for estimation of its parameters. Under this simplification, the posterior density is a product of exponential family members, hence under EM-style approximate estimation this class itself belongs to the exponential family.

TODO: Extend BM to use rvc.

## Member Function Documentation

void MixEF::init | ( | BMEF * | Com0,
|  | const mat & | Data,
|  | int | c = `5` |
| ) |  |  |

Initializing the mixture by a random pick of centroids from data

Parameters:

  | Com0 | Initial component - necessary to determine its type.
  | Data | Data on which the initialization will be done
  | c | Initial number of components, default=5

References BMEF::_copy_(), build_est(), Coms, est, n, multiBM::set_parameters(), and weights.

Referenced by merger::merge().

double MixEF::logpred | ( | const vec & | dt | ) | const`[virtual]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented from BM.

References multiBM::_epdf(), Coms, epdf::mean(), and weights.

Referenced by merger::evallog(), and merger::merge().

The documentation for this class was generated from the following files:

- work/git/mixpp/bdm/estim/mixef.h
- work/git/mixpp/bdm/estim/mixef.cpp